-----------------------------------------------------------------------------------------
-- Start Activity
-----------------------------------------------------------------------------------------
function WeaponTest:StartActivity()
	print ("WeaponTest:Tactics:StartActivity");

	if self.IsInitialized == nil then
		self.IsInitialized = false
	end

	if self.IsInitialized then 
		return
	end

	self.ModuleName = "WeaponTest.rte";
	
	LIB_PATH = self.ModuleName.."/Scripts/"
	BASE_PATH = self.ModuleName.."/Scripts/"

	dofile(LIB_PATH.."CF_ConfigLibrary.lua");
	dofile(LIB_PATH.."CF_MissionLibrary.lua");	
	
	self.IsInitialized = true
	
	-------------------------------------------------------------
	-------------------------------------------------------------
	-------------------------------------------------------------
	-- Weapon lists
	self.Weapons = {"M60"}
	self.Explosives = {}
	--self.Weapons = {"Fake Pistol"}
	--self.Weapons = {"XM-13 Wormhole Emitter", "XM-75 Type D Machinegun", "XM-92B Heavy Sniper" ,"XM-10 Submachine Gun", "XM-2 Pistol"}
	--self.Weapons = {"Smpl. #01 Psi Lightning Orb"}	
	--self.Explosives = {"XM-14 Wormhole Grenade","XM-14 Wormhole Grenade","XM-14 Wormhole Grenade"}
	--self.Explosives = {"XM-45 Brain Seeker Pod","XM-45 Brain Seeker Pod","XM-45 Brain Seeker Pod"}
	--self.EnemyWeapons = {"Wormhole"}
	self.EnemyExplosives = {}
	self.EnemyWeapons = {"Fake Pistol"}
	--self.EnemyWeapons = {"M60", "Thumper", "RPG-7", "Revolver Cannon"}
	--self.EnemyWeapons = nil -- Set nil to give standard faction weapons
	--SceneMan:MakeAllUnseen(Vector(100, 100), 0);	
	-------------------------------------------------------------
	-------------------------------------------------------------
	-------------------------------------------------------------
	
	self.SpawnCrafts = false
	
	CF_InitFactions(self)
	self.PlayableFactions = {}
	for i = 1, #CF_Factions do
		if CF_FactionPlayable[CF_Factions[i]] then
			self.PlayableFactions[#self.PlayableFactions + 1] = CF_Factions[i]
		end
	end
	
	print("START")
	
	-- Initial settings
	self.EnemyFaction = math.random(#self.PlayableFactions)
	self.EnemySpawnInterval = 10
	self.EnemySpawnAmount = 3
	self.EnemyType = 1
	self.GroupTargets = false;
	self.DummyMode = false
	
	
	self.TotalHealth = 0
	self.CurrentHealth = 0
	self.TotalDamage = 0
	self.DamagePerSecond = 0
	self.MaxDamagePerSecond = 0
	self.TotalImpulse = 0
	self.MeasureStart = 0
	
	self.SelectableTypes = {CF_ActorTypes.LIGHT, CF_ActorTypes.HEAVY, CF_ActorTypes.ARMOR}
	
	self.SelectedValue = 1
	
	-- Get areas
	self.AtkBrain = SceneMan.Scene:GetArea("AtkBrain")
	self.AtkTrooper = SceneMan.Scene:GetArea("AtkTrooper")

	self.SafeZone = SceneMan.Scene:GetArea("SafeZone")
	self.Controller = SceneMan.Scene:GetArea("Controller")
	
	self.PlayerTeam = 0
	self.CPUTeam = 1
	
	-- Get defenders areas
	self.DefTrooper = {}
	self.DefTrooper[1] = SceneMan.Scene:GetArea("DefTrooper1")
	self.DefTrooper[2] = SceneMan.Scene:GetArea("DefTrooper2")
	self.DefTrooper[3] = SceneMan.Scene:GetArea("DefTrooper3")
	self.DefTrooper[4] = SceneMan.Scene:GetArea("DefTrooper4")
	self.DefTrooper[5] = SceneMan.Scene:GetArea("DefTrooper5")
	self.DefTrooper[6] = SceneMan.Scene:GetArea("DefTrooper6")
	
	-- Spawn player brain
	--[[local brain = self:MakeActor("Brain Robot", "Base.rte")
	if brain ~= nil then
		brain.Team = self.PlayerTeam
		brain.Pos = self.AtkBrain:GetCenterPoint();
		MovableMan:AddActor(brain);
	end--]]--

	-- Spawn controller
	local actor = CreateActor("Controller", self.ModuleName)
	if actor ~= nil then
		actor.Team = self.PlayerTeam
		actor.Pos = self.Controller:GetCenterPoint();
		MovableMan:AddActor(actor);
		
		self:SwitchToActor(actor, 0, 0);
	end
	
	-- Spawn player actor
	local actor = self:MakeActor("Soldier Heavy", "Coalition.rte")
	--local actor = self:MakeActor("Psyclone Heavy", "Psyclones.rte")
	if actor ~= nil then
		actor.Team = self.PlayerTeam
		actor.Pos = self.AtkTrooper:GetCenterPoint();
		MovableMan:AddActor(actor);

		for i = 1, #self.Weapons do
			local weap = CreateHDFirearm(self.Weapons[i])
			if weap ~= nil then
				actor:AddInventoryItem(weap)
			end
		end

		for i = 1, #self.Explosives do
			local weap = CreateTDExplosive(self.Explosives[i])
			if weap ~= nil then
				actor:AddInventoryItem(weap)
			end
		end
	end--]]--

	--[[local actor = CreateACrab("Brain Seeker", "Psyclones.rte")--self:MakeActor("Brain Seeker", "Psyclones.rte")
	if actor ~= nil then
		actor.Team = self.PlayerTeam
		actor.Pos = self.AtkTrooper:GetCenterPoint() + Vector(-100,0);
		MovableMan:AddActor(actor);
	end

	local actor = CreateACrab("Sarcophagus", "Psyclones.rte")--self:MakeActor("Brain Seeker", "Psyclones.rte")
	if actor ~= nil then
		actor.Team = self.PlayerTeam
		actor.Pos = self.AtkTrooper:GetCenterPoint() + Vector(-200,0);
		MovableMan:AddActor(actor);
	end--]]--
	
	-- Create enemy brain to test
	--[[local eb = CreateActor("Brain Case")
	if eb then
		eb.Team = 2;
		eb.Pos = Vector(3500,500)
		MovableMan:AddActor(eb)
	end--]]--
	
	--[[local actor = self:MakeActor("Psyclone Medium", "Psyclones.rte")
	if actor ~= nil then
		actor.Team = self.PlayerTeam
		actor.Pos = self.AtkTrooper:GetCenterPoint() + Vector(-50,0);
		MovableMan:AddActor(actor);

		for i = 1, #self.Weapons do
			local weap = CreateHDFirearm(self.Weapons[i])
			if weap ~= nil then
				actor:AddInventoryItem(weap)
			end
		end
	end--]]--
	
	-- Add all weapons to brain and actor
	--[[for i = 1, #self.Weapons do
		local weap = CreateHDFirearm(self.Weapons[i])
		if weap ~= nil then
			brain:AddInventoryItem(weap)
		end
	end--]]--
	
	-- Spawn player actor
	self.GenericTimer = Timer();
	self.GenericTimer:Reset();
	
	self.IsInitialized = true
	
	self:SetTeamFunds(1000000, 0);
	
	self:SpawnEnemyActors();
end
-----------------------------------------------------------------------------------------
-- Make brain where c - config, p - player, pay - if true then pay for unit
-----------------------------------------------------------------------------------------
function WeaponTest:MakeActor(preset, module)
	local actor = nil
	local weapon = nil;
	
	actor = CreateAHuman(preset, module)
	if actor ~= nil then
		actor.AIMode = Actor.AIMODE_SENTRY;
	end
	
	return actor;
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function WeaponTest:SpawnRandomInfantry(team , pos , faction , aimode, actortype)
	--print ("CF_SpawnRandomInfantry");
	local actor = nil;
	local r1, r2;
	local item;
	
	if MovableMan:GetMOIDCount() < CF_MOIDLimit then
		-- Find AHuman
		local ok = false;
		-- Emergency counter in case we don't have AHumans in factions
		local counter = 0
		
		while (not ok) do
			ok = false;
			r1 = math.random(#CF_ActNames[faction])

			if CF_ActTypes[faction][r1] == actortype and (CF_ActClasses[faction][r1] == nil or CF_ActClasses[faction][r1] == "AHuman") then
				ok = true;
			end
			
			-- Break to avoid endless loop
			counter = counter + 1
			if counter > 80 then
				break
			end
		end
	
		actor = CF_MakeActor(CF_ActPresets[faction][r1] , CF_ActClasses[faction][r1], CF_ActModules[faction][r1]);
		
		if actor ~= nil then
			if self.EnemyWeapons ~= nil and #self.EnemyWeapons > 0 then
				for j = 1, #self.EnemyWeapons do
					item = CreateHDFirearm(self.EnemyWeapons[j])
					if item ~= nil then
						actor:AddInventoryItem(item);
					end
				end
			else
				-- Find rifle
				local ok = false;
				-- Emergency counter in case we don't have AHumans in factions
				local counter = 0
				
				while (not ok) do
					ok = false;
					r2 = math.random(#CF_ItmNames[faction])
			
					if CF_ItmTypes[faction][r2] == CF_WeaponTypes.RIFLE or CF_ItmTypes[faction][r2] == CF_WeaponTypes.SHOTGUN or CF_ItmTypes[faction][r2] == CF_WeaponTypes.SNIPER or CF_ItmTypes[faction][r2] == CF_WeaponTypes.HEAVY then
						ok = true;
					end
					
					-- Break to avoid endless loop
					counter = counter + 1
					if counter > 40 then
						break
					end
				end
			
				item = CF_MakeItem(CF_ItmPresets[faction][r2] , CF_ItmClasses[faction][r2], CF_ItmModules[faction][r2]);
				
				if item ~= nil then
					actor:AddInventoryItem(item);
				end
			end

			if self.EnemyExplosives ~= nil and #self.EnemyExplosives > 0 then
				for j = 1, #self.EnemyExplosives do
					item = CreateTDExplosive(self.EnemyExplosives[j])
					if item ~= nil then
						actor:AddInventoryItem(item);
					end
				end
			end
			
			actor.AIMode = aimode;
			actor.Team = team;
			
			if pos ~= nil then
				actor.Pos = pos;
				MovableMan:AddActor(actor);
			else
				return actor
			end
		end
	end
	
	return nil
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function WeaponTest:SpawnEnemyActors()
	if self.DummyMode then
		-- Clear stats
		self.TotalHealth = 0
		self.CurrentHealth = 0
		self.TotalDamage = 0
		self.DamagePerSecond = 0
		self.MaxDamagePerSecond = 0
		self.TotalImpulse = 0
		self.MeasureStart = 0
		
		-- Delete previous actors
		for actor in MovableMan.Actors do
			if actor.Team ~= 0 then
				actor.ToDelete = true
			end
		end
	
		-- Spawn dummies
		for i = 1, self.EnemySpawnAmount do
			local actor = CreateAHuman("Ronin Dummy")
			if actor ~= nil then
				actor.Team = 1
				actor.AIMode = Actor.AIMODE_SENTRY
				if self.GroupTargets then
					actor.Pos = self.DefTrooper[1]:GetCenterPoint();
				else
					actor.Pos = self.DefTrooper[i]:GetCenterPoint() + Vector(-5 + math.random(10), 0);
				end
				
				local itm = CreateHDFirearm("Fake Pistol")
				if itm then
					actor:AddInventoryItem(itm)
				end
				
				MovableMan:AddActor(actor);
				
				self.CurrentHealth = self.CurrentHealth + actor.Health
			end
		end
		
		self.TotalHealth = self.CurrentHealth
	else
		for i = 1, self.EnemySpawnAmount do
			local actor = self:SpawnRandomInfantry(self.CPUTeam, nil, self.PlayableFactions[self.EnemyFaction], Actor.AIMODE_SENTRY, self.SelectableTypes[self.EnemyType])
			if actor ~= nil then
				if self.GroupTargets then
					actor.Pos = self.DefTrooper[1]:GetCenterPoint();
				else
					actor.Pos = self.DefTrooper[i]:GetCenterPoint() + Vector(-5 + math.random(10), 0);
				end
				MovableMan:AddActor(actor);
			end
		end
	end
	
	if self.SpawnCrafts then
		local f = self.PlayableFactions[self.EnemyFaction]
		local actor = CF_MakeActor(CF_Crafts[f] , CF_CraftClasses[f] , CF_CraftModules[f]);
		if actor ~= nil then
			actor.Team = self.CPUTeam
			actor.AIMode = Actor.AIMODE_DELIVER
			actor.Pos = Vector(self.DefTrooper[3]:GetCenterPoint().X, 0);
			MovableMan:AddActor(actor);
		end
	end
end
-----------------------------------------------------------------------------------------
--
-----------------------------------------------------------------------------------------
function WeaponTest:ProcessUI()
	local act = self:GetControlledActor(self.PlayerTeam);
	
	if self.DummyMode then
		-- Show damage stats
		self.CurrentHealth = 0
		for actor in MovableMan.Actors do
			if actor.Team == 1 then
				self.CurrentHealth = self.CurrentHealth + actor.Health
			end
		end
		
		if self.CurrentHealth > 0 then
			if self.MeasureStart == 0 then
				if self.TotalDamage > 0 then
					self.MeasureStart = self.GenericTimer.ElapsedSimTimeS
				end
			end
			
			self.TotalDamage = self.TotalHealth - self.CurrentHealth
			if self.TotalDamage > 0 then
				self.DamagePerSecond = math.ceil(self.TotalDamage / (self.GenericTimer.ElapsedSimTimeS - self.MeasureStart + 1))
			else
				self.DamagePerSecond = 0
			end
			
			if self.DamagePerSecond > self.MaxDamagePerSecond then
				self.MaxDamagePerSecond = self.DamagePerSecond
			end
			
			local timeleft = self.EnemySpawnInterval - self.GenericTimer.ElapsedSimTimeS
			
			local s = ""
			s = s .. "T- "..math.ceil(timeleft).."\n"
			s = s .. "DAM: "..self.TotalDamage.."\n"
			if self.MeasureStart > 0 then
				s = s .. "DPS: "..self.DamagePerSecond.."\n"
				s = s .. "MAX: "..self.MaxDamagePerSecond.."\n"
			else
				s = s .. "DPS: N/A\n"
				s = s .. "MAX: N/A\n"
			end
			
			self:AddObjectivePoint(s, self.DefTrooper[1]:GetCenterPoint() + Vector(0,-50) , 0, GameActivity.ARROWDOWN);
		end
	end
	
	-- Process delivery controls
	if MovableMan:IsActor(act) and act.PresetName == "Controller" then
		local cont = act:GetController()
		
		-- Switch to prev preset
		if cont:IsState(Controller.PRESS_UP) then
			self.SelectedValue = self.SelectedValue - 1
			if self.SelectedValue < 1 then
				self.SelectedValue = 7
			end
		end

		-- Switch to next preset
		if cont:IsState(Controller.PRESS_DOWN) then
			self.SelectedValue = self.SelectedValue + 1
			if self.SelectedValue > 7 then
				self.SelectedValue = 1
			end
		end

		if cont:IsState(Controller.PRESS_LEFT) or cont:IsState(Controller.PRESS_RIGHT) then
			if self.SelectedValue == 1 then
				if cont:IsState(Controller.PRESS_LEFT) then
					self.EnemyFaction = self.EnemyFaction - 1
					if self.EnemyFaction == 0 then
						self.EnemyFaction = #self.PlayableFactions
					end
				end
			
				if cont:IsState(Controller.PRESS_RIGHT) then
					self.EnemyFaction = self.EnemyFaction + 1
					if self.EnemyFaction == #self.PlayableFactions + 1 then
						self.EnemyFaction = 1
					end
				end
			end
			
			if self.SelectedValue == 2 then
				if cont:IsState(Controller.PRESS_LEFT) then
					self.EnemySpawnInterval = self.EnemySpawnInterval - 1
					if self.EnemySpawnInterval == 4 then
						self.EnemySpawnInterval = 15
					end
				end
			
				if cont:IsState(Controller.PRESS_RIGHT) then
					self.EnemySpawnInterval = self.EnemySpawnInterval + 1
					if self.EnemySpawnInterval == 16 then
						self.EnemySpawnInterval = 5
					end
				end
			end
			
			if self.SelectedValue == 3 then
				if cont:IsState(Controller.PRESS_LEFT) then
					self.EnemySpawnAmount = self.EnemySpawnAmount - 1
					if self.EnemySpawnAmount == 0 then
						self.EnemySpawnAmount = 7
					end
				end
			
				if cont:IsState(Controller.PRESS_RIGHT) then
					self.EnemySpawnAmount = self.EnemySpawnAmount + 1
					if self.EnemySpawnAmount == 7 then
						self.EnemySpawnAmount = 1
					end
				end
			end

			if self.SelectedValue == 4 then
				if cont:IsState(Controller.PRESS_LEFT) then
					self.EnemyType = self.EnemyType - 1
					if self.EnemyType == 0 then
						self.EnemyType = #self.SelectableTypes
					end
				end
			
				if cont:IsState(Controller.PRESS_RIGHT) then
					self.EnemyType = self.EnemyType + 1
					if self.EnemyType == #self.SelectableTypes + 1 then
						self.EnemyType = 1
					end
				end

				--[[if self.EnemyType == CF_ActorTypes.LIGHT then
					self.EnemyType = CF_ActorTypes.HEAVY
				elseif self.EnemyType == CF_ActorTypes.ARMOR then
					self.EnemyType = CF_ActorTypes.LIGHT
				end]]--
			end
			
			if self.SelectedValue == 5 then
				self.SpawnCrafts = not self.SpawnCrafts;
			end
			
			if self.SelectedValue == 6 then
				self.GroupTargets = not self.GroupTargets
			end

			if self.SelectedValue == 7 then
				self.DummyMode = not self.DummyMode
			end
		end

		
		--local glow = CreateMOPixel("SideMenuButtonIdle", self.ModuleName);
		--glow.Pos = act.Pos + Vector(0,-40)
		--MovableMan:AddParticle(glow);			

		CF_DrawString(">                       <", act.Pos + Vector(-60,self.SelectedValue * 10), 200, 200);

		CF_DrawString("Faction", act.Pos + Vector(-50 , 10), 200, 200);
		CF_DrawString(self.PlayableFactions[self.EnemyFaction], act.Pos + Vector(30 , 10), 200, 200);

		CF_DrawString("Interval", act.Pos + Vector(-50 , 20), 200, 200);
		CF_DrawString(tostring(self.EnemySpawnInterval), act.Pos + Vector(30 , 20), 200, 200);

		CF_DrawString("Amount", act.Pos + Vector(-50 , 30), 200, 200);
		CF_DrawString(tostring(self.EnemySpawnAmount), act.Pos + Vector(30 , 30), 200, 200);

		CF_DrawString("Type", act.Pos + Vector(-50 , 40), 200, 200);
		if self.SelectableTypes[self.EnemyType] == CF_ActorTypes.LIGHT then
			CF_DrawString("LIGHT", act.Pos + Vector(30 , 40), 200, 200);
		end
		if self.SelectableTypes[self.EnemyType] == CF_ActorTypes.HEAVY then
			CF_DrawString("HEAVY", act.Pos + Vector(30 , 40), 200, 200);
		end
		if self.SelectableTypes[self.EnemyType] == CF_ActorTypes.ARMOR then
			CF_DrawString("ARMOR", act.Pos + Vector(30 , 40), 200, 200);
		end
		
		CF_DrawString("Crafts", act.Pos + Vector(-50 , 50), 200, 200);
		if self.SpawnCrafts  then
			CF_DrawString("YES", act.Pos + Vector(30 , 50), 200, 200);
		else
			CF_DrawString("NO", act.Pos + Vector(30 , 50), 200, 200);
		end
		
		CF_DrawString("Group", act.Pos + Vector(-50 , 60), 200, 200);
		if self.GroupTargets then
			CF_DrawString("YES", act.Pos + Vector(30 , 60), 200, 200);
		else
			CF_DrawString("NO", act.Pos + Vector(30 , 60), 200, 200);
		end
		
		CF_DrawString("Dummy mode", act.Pos + Vector(-50 , 70), 200, 200);
		if self.DummyMode then
			CF_DrawString("ON", act.Pos + Vector(30 , 70), 200, 200);
		else
			CF_DrawString("OFF", act.Pos + Vector(30 , 70), 200, 200);
		end
		
	end
end
-----------------------------------------------------------------------------------------
-- Pause Activity
-----------------------------------------------------------------------------------------
function WeaponTest:PauseActivity(pause)
end
-----------------------------------------------------------------------------------------
-- End Activity
-----------------------------------------------------------------------------------------
function WeaponTest:EndActivity()
end
-----------------------------------------------------------------------------------------
-- Update Activity
-----------------------------------------------------------------------------------------
function WeaponTest:UpdateActivity()
	-- Just check for intialization flags in update loop to avoid unnecessary function calls during all the mission
	if self.IsInitialized == nil then
		self.IsInitialized = false
	end
	
	if not self.IsInitialized then
		--Init mission if we're still not
		self:StartActivity()
	end

	-- Reload all scripts on space
	if UInputMan:KeyPressed(75) then
		print ("Reload scripts")
		PresetMan:ReloadAllScripts();
	end
	
	if UInputMan:KeyPressed(2) then
		if self.ActivityState == Activity.EDITING then
			self.ActivityState = Activity.RUNNING
		else
			self.ActivityState = Activity.EDITING
		end
	end		
	
	
	if self.ActivityState == Activity.EDITING then
		MovableMan:OpenAllDoors(true, Activity.NOTEAM)
	else	
		self:ClearObjectivePoints();
		
		self:ProcessUI()	
		
		-- Kill escaping actors
		--[[for actor in MovableMan.Actors do
			if actor.Team == self.CPUTeam and actor.Health > 0 then
				actor.AIMode = Actor.AIMODE_SENTRY;
				
				if not self.SafeZone:IsInside(actor.Pos) then
					actor.Health = 0 --actor.Health - 1
					actor.Vel = Vector(20 + math.random(10), -30 - math.random(10));
				end
				
				actor:GetController():SetState(Controller.BODY_CROUCH, false)
			end
		end--]]--
		
		-- Destroy items
		for item in MovableMan.Items do
			if self.SafeZone:IsInside(item.Pos) then
				--item.ToSettle = true
			end
		end
		
		if self.GenericTimer:IsPastSimMS(self.EnemySpawnInterval * 1000) then
			self:SpawnEnemyActors();
			self.GenericTimer:Reset();
		end
	end
	
	--self:DoBrainSelection()
	self:YSortObjectivePoints();
end
-----------------------------------------------------------------------------------------
-- Brain selection and gameover conditions check
-----------------------------------------------------------------------------------------
function WeaponTest:DoBrainSelection()
	if self.ActivityState ~= Activity.OVER then
		for player = 0, self.PlayerCount - 1 do
			local team = self:GetTeamOfPlayer(player);
			local brain = self:GetPlayerBrain(player);

			if not brain or not MovableMan:IsActor(brain) or not brain:HasObjectInGroup("Brains") then
				if team == self.PlayerTeam then
					self.PlayerBrainDead = true
				end

				self:SetPlayerBrain(nil, player);
				local newBrain = MovableMan:GetUnassignedBrain(team);
				if newBrain then
					self:SetPlayerBrain(newBrain, player);
					self:SwitchToActor(newBrain, player, team);
					
					if team == self.PlayerTeam then
						self.PlayerBrainDead = false
					end
				end
			else
				self:SetObservationTarget(brain.Pos, player)
			end
		end
	end
end
-----------------------------------------------------------------------------------------
-- Thats all folks!!!
-----------------------------------------------------------------------------------------